/*
 * RectBoard.java
 *
 * Created on 19. jen 2006, 23:48
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package pa161.uloha_2;

/**
 *
 * @author xmatena
 */
public class RectBoard {
    int board[][] = new int[3][3];
    
    /** Creates a new instance of RectBoard */
    public RectBoard() {
    }
    
    /**
     * Creates a new instance of RectBoard
     * @param ul upper-left corner value
     * @param um ..
     * @param ur ..
     * @param ml ..
     * @param mm ..
     * @param mr ..
     * @param dl ..
     * @param dm ..
     * @param dr - down right value
     */
    public RectBoard(int ul, int um, int ur, int ml, int mm, int mr, int dl, int dm, int dr) {
        board[0][0] = ul;
        board[1][0] = um;
        board[2][0] = ur;
        board[0][1] = ml;
        board[1][1] = mm;
        board[2][1] = mr;
        board[0][2] = dl;
        board[1][2] = dm;
        board[2][2] = dr;
        
    }
    
    
    
    /**
     * Prints out the state in ASCII
     * @return ASCII
     */
    public String drawState() {
        int[][] st = this.board;
        return ("+-+-+-+\n|" + st[0][0] + "|" + st[1][0] + "|" + st[2][0] + "|\n" +
                "+-+-+-+\n" +
                "|" + st[0][1] + "|" + st[1][1] + "|" + st[2][1] + "|\n" +
                "+-+-+-+\n" +
                "|" + st[0][2] + "|" + st[1][2] + "|" + st[2][2] + "|\n" +
                "+-+-+-+\n");
    }
    
    /**
     * Calculates the RectBoard after the best step using selected heuristics
     * @param goal the RectBoard to reach
     * @return RectBoard following
     */
    public ReturnStruct getBoardAfterBestMove(RectBoard goal,int heuristics, int depth) {
        int x = this.getXof(0);
        int y = this.getYof(0);
        
        int bestDelta = 99;
        int actualDelta;
        ReturnStruct result = null;
        ReturnStruct actual = null;
        RectBoard actBoard;
        
        //try to get a tile from up
        if (y > 0) {
            actBoard = getNewBoardFrom(this,this.board[x][y-1]);
            if (actBoard.equals(goal)) {
                result = new ReturnStruct(actBoard,0);
            }
            if (depth > 0) {
                ReturnStruct rs = actBoard.getBoardAfterBestMove(goal,heuristics,depth-1);
                actualDelta = rs.getLowestCount();
            } else {
                actualDelta = (heuristics == 1)? actBoard.badPlace(goal) : actBoard.manhattanDist(goal);
            }
            
            if ((actualDelta < bestDelta) || (result == null)) {
                bestDelta = actualDelta;
                result = new ReturnStruct(actBoard,actualDelta);
            }
        }
        
        if (x < 2) {
            actBoard = getNewBoardFrom(this,this.board[x+1][y]);
            if (actBoard.equals(goal)) {
                result = new ReturnStruct(actBoard,0);
            }
            if (depth > 0) {
                ReturnStruct rs = actBoard.getBoardAfterBestMove(goal,heuristics,depth-1);
                actualDelta = rs.getLowestCount();
            } else {
                actualDelta = (heuristics == 1)? actBoard.badPlace(goal) : actBoard.manhattanDist(goal);
            }
            
            if ((actualDelta < bestDelta) || (result == null)) {
                bestDelta = actualDelta;
                result = new ReturnStruct(actBoard,actualDelta);
            }
        }

        
        if (y < 2) {
            actBoard = getNewBoardFrom(this,this.board[x][y+1]);
            if (actBoard.equals(goal)) {
                result = new ReturnStruct(actBoard,0);
            }
            if (depth > 0) {
                ReturnStruct rs = actBoard.getBoardAfterBestMove(goal,heuristics,depth-1);
                actualDelta = rs.getLowestCount();
            } else {
                actualDelta = (heuristics == 1)? actBoard.badPlace(goal) : actBoard.manhattanDist(goal);
            }
            
            if ((actualDelta < bestDelta) || (result == null)) {
                bestDelta = actualDelta;
                result = new ReturnStruct(actBoard,actualDelta);
            }
        }
        
        
        if (x > 0) {
            actBoard = getNewBoardFrom(this,this.board[x-1][y]);
            if (actBoard.equals(goal)) {
                result = new ReturnStruct(actBoard,0);
            }
            if (depth > 0) {
                ReturnStruct rs = actBoard.getBoardAfterBestMove(goal,heuristics,depth-1);
                actualDelta = rs.getLowestCount();
            } else {
                actualDelta = (heuristics == 1)? actBoard.badPlace(goal) : actBoard.manhattanDist(goal);
            }
            
            if ((actualDelta < bestDelta) || (result == null)) {
                bestDelta = actualDelta;
                result = new ReturnStruct(actBoard,actualDelta);
            }
        }
        if (Rectangles.VERBOSE) {
            for (int i = Rectangles.DEPTH; i > depth; i--) {
                System.out.print(" ");
            }
            System.out.println(bestDelta);
        }
        
        return result;
    }
    
    public static RectBoard getNewBoardFrom(RectBoard previous, int numToMove) {
        RectBoard result = new RectBoard();
        result.setBoard(previous.getBoard());
        
        result.moveField(result.getXof(numToMove), result.getYof(numToMove), result.getXof(0), result.getYof(0));
        return result;
    }
    
    
    //returns true if move is possible
    public boolean moveField(int x1,int y1, int x2, int y2 ) {
        int help;
        help = board[x1][y1];
        board[x1][y1] = board[x2][y2];
        board[x2][y2] = help;
        if ((help == 0) || (board[x1][y1] == 0)) {
            return true;
        } else {
            return false;
        }
    }
    
    /**
     * Bad place heuristics
     * @param goal the RectBoard to reach
     * @return distance
     */
    public int badPlace(RectBoard goal) {
        int result = 0;
        for (int i = 0; i<3; i++) {
            for (int j = 0; j<3; j++) {
                if(this.board[i][j] != goal.board[i][j]) {
                    result++;
                }
            }
        }
        return result;
    }
    
    /**
     * Manhattan heuristics
     * @param goal
     * @return
     */
    public int manhattanDist(RectBoard goal) {
        int result = 0;
        int x;
        int y;
        int dist;
        for (int i = 0; i<3; i++) {
            for (int j = 0; j<3; j++) {
                x = this.getXof(goal.board[i][j]);
                y = this.getYof(goal.board[i][j]);
                dist = Math.abs(x - i) + Math.abs(y - j);
                result = result + dist;
            }
        }
        return result;
    }
    
    /**
     * Find the x-coord of a number
     */
    public int getXof(int num) {
        int result = -1;
        for (int i = 0; i<3; i++) {
            for (int j = 0; j<3; j++) {
                if(this.board[i][j] == num) {
                    return i;
                }
            }
        }
        return result;
    }
    
    /**
     * Find the x-coord of a number
     */
    public int getYof(int num) {
        int result = -1;
        for (int i = 0; i<3; i++) {
            for (int j = 0; j<3; j++) {
                if(this.board[i][j] == num) {
                    return j;
                }
            }
        }
        return result;
    }
    
    /**
     * Overriden
     * @param obj Object to compare with
     * @return true ifff the RectBoard in obj represents the same board
     */
    public boolean equals(Object obj) {
        if (obj instanceof RectBoard) {
            int dist = this.badPlace((RectBoard) obj);
            return (dist == 0);
        } else {
            return false;
        }
    }
    
    public int[][] getBoard() {
        int board2[][] = new int[3][3];
        for (int i = 0; i<3; i++) {
            for (int j = 0; j<3; j++) {
                board2[i][j] = board[i][j];
                
            }
        }
        
        return board2;
    }
    
    public void setBoard(int board[][]) {
        this.board = board;
    }
    
}

class ReturnStruct {
    private RectBoard rb;
    private int lowestCount;
    public ReturnStruct(RectBoard rb, int lowestCount) {
        this.setRb(rb);
        this.setLowestCount(lowestCount);
    }
    
    public RectBoard getRb() {
        return rb;
    }
    
    public void setRb(RectBoard rb) {
        this.rb = rb;
    }
    
    public int getLowestCount() {
        return lowestCount;
    }
    
    public void setLowestCount(int lowestCount) {
        this.lowestCount = lowestCount;
    }
}
